////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// eslint
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// globals from common.js - override .eslintrc.json defaults
/* globals load_hooks_impl:true debug:true info:true warn:true error:true officeEditingDistributionIds officeFileExtension2Mime */

// globals from background.js
/* global day_msec,items,hashes,phishingEntries,downloadsInProgress,urlsInProgress,mapUrlToReqHeaders,mapUrlToContentLength,cancelledDownloads,closedNotifications,
tempExcludedDomains,oneTimeLinkDomains,urlDownloadedByExtension,indicators_def,mapUrlToPostData,notificationsMap,backgroundNotificationsMap,notificationsArray,lastError:true,
iconTimer,iconState,downloading_icons,scanning_icons,savedSites,tabErrors,tabRedirects,browserHistory,supported_office_pdf_formats,supported_binary_file_formats,asciiCodes,
loadSettingsTimerId,reputationService,iot_default_creds,common_passwords,version,noFavicon,cpFavicon,cpOldFavicon,contextMenuIDs,noTexDownloadId,is_automation,google_key,
google_cx,offline_logs,resend_log_timeout_id,agent_resend_log_timeout_id,sending_offline_logs,show_friendly_page,getOrigDomain,loggedUrls,lastPasswordReuseUrl,demo_iv,
continue_anyway_entries,te_query_internal,_gaq,trackAction,getAccountId,getTrackingId,getFileInfo,getLogPrefix,getLogPrefixById,run_register_hooks,getRandomToken,isRandomToken,
getFamilyFlagByExt,fileTypeSupported,calculate_derived_settings,calculate_parts,calculate_te_environment_objects,add_setting_default_value,add_settings_default_value,
installSettings,getCleanOfflineLogs,get_policy_from_server,get_policy,loadSettings,remove_expired_notificaitons,load_notifications,remove_orig_file_from_storage,
get_orig_file_info_from_storage,store_orig_file_info_in_storage,max_te_queries,handleScrubResultError,fileWasCleaned,handleScrubResult,handleScrubResultCloud,parseTEResponse,
parseTEXResponse,parseStatusResponse,handleTEStatusResult,calculate_file_sha1,checkTECache,checkTEStatus,handleTEError,beginCheckTEStatus,checkTEXStatusCloud,
downloadScrubResultCloud,setFileInfoCookie,filenameBase64Encode,filenameBase64Decode,sendFileToServer,serialize,checkFileSize,handleFile,handleGetFileError,getFile,
SetOneTimeBypass,HasOneTimeBypass,handleServerError,sendBrowserNotification,getNotification,setNotificationMessage,setNotificationOrigFileState,storeNotificationsArray,
sendNotification,event_notification_by_user_closed,event_notification_automatically,downloadFileAsync,downloadFileBuffer,downloadFile,downloadDone,is_service_url,append_headers,
deleteNoLongerProtectedHashes,cancelDownloadInProgress,notification_clicked,setting_activated,setting_disabled,handle_retry_get_orig,retry_get_orig_file,handle_get_orig,
download_orig_file,get_favicon,is_user_home_dir,is_domain,is_domain_in_url_path,get_domain_from_title,title_domain_mismatch,is_image_only,getTitle,has_many_errors,
text_to_image,has_suspicious_text,startSiteScan,notifyEndScan,saveScannedSite,sendSiteLogIfNeeded,sendStatsDelayed,endSiteScan,cancel_scan,save_new_settings,
handle_password_reuse,secureHash,password_compliance_notification,check_password_compliance,check_password_reuse,forget_old_password_if_changed,protect_password_reuse,is_google,
is_whitelisted,isEnglishChar,isUnicodeChar,isEnglishAndUnicode,textContainsConfusableWords,content_script_load,getConfigurationAsRegistryString,handle_message_request,
collect_debug,get_usercheck_content,stopBadgeAnimation,badgeAnimate,setBadge,takeAction,is_get_orig_url,is_file_protocol,is_ftp_protocol,handle_file_download,
check_connection_and_download_file,modify_responseHeaders,savePostData,getStatsFromEntry,sendStats,sendGwStats,getValue,isExpiredOfflineLog,startSendingOfflineLogs,
sendNextOfflineLog,enqueueOfflineLog,dequeueOfflineLog,postLog,sendLogToCloud,replaceApostrophe,createLogForAgentFromJson,sendLogToGateway,sendLog,onFileHandlingDone,
createLogForAgent,sendLogToAgent,sendGetOriginalLog,sendBlockOrAllowTELog,sendTELog,sendTEXLog,sendUserActivationLog,sendContinueAnywayLog,sendPasswordReuseLog,getScanTime,
sendSiteLog,getFavIconHash,getFavIcon,is_same_org,add_new_entry,add_new_entry_sync,add_trusted_entries,clearSite,get_domain_suffix,domain_in_domain,is_multiple_labels_in_domain,
has_many_words_in_domain,search_in_rep,is_similar_title,search_in_search_engine,showUserCheckPopupForHTTPOnly,getPath,getPort,isSuspiciousReferrer,verdicts,getVerdictDesc,
getVerdictString,isSameEmailSuffix,isSameCert,count_occurences,isOffline,isFalsePositive,showUserCheckIfRequiredEx,showUserCheckIfRequired,count_significant_words,find_similar_domain,
log_collect_key,decrypt_text,encrypt_text,init_advanced_indicators,init_indicators_def,get_advanced_text_for_indicator,get_basic_text_for_indicator,get_unique_findings2,
findings_to_text,test_demo_key,get_text_for_indicator,get_matched_external_domain,doSiteScan,isBadClassification,handleCategorizeResponse,categorizeUrl,categorizeDomain,
start_scan,continue_scan,cropPlusExport,cropAndOcr,detectLogoFromScreenshot,captureScreen,get_domain_name,is_same_base_domain,is_logo_domain_match,is_similar_base_domain,
is_similar_url,find_similar_url,get_copyright,find_similar_trusted_domain,distance,find_similar_favicon,add_browser_history_result,scan_data_url,notify_error,clear_tab_info,
set_settings_from_url,check_managed_changes,apply_managed_changes,connection_check_callback,connection_check,getExternalDomain,url_encoded_url,newURL,blockFlash,qwerty,qwertz,
azerty,keyboards,bitsquatting,homoglyph,hyphenation,insertion,omission,repetition,replacement,subdomain,transposition,domain_fuzzer,convertToImageData,checkZALicense,enforceLicense,
daily_event,sendDailyPing,run_and_sched_daily_event,decode_findings,saveCollectedLogs,mailTo,getCurrentCountry,getScrubbedFileName,modifyRandomByte,sendURLToEmulationInCloud,
sendFileToEmulationInCloud,parseCloudStatusResponse,get_te_cloud_server,stripHtml,force_safe_search,urlf_check
*/

// browser apis
/* global browser chrome */

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// code
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function load_chrome_hooks() {
	//info("loading chrome hooks");
	funcs.set_badge_text				= chrome_set_badge_text;
	funcs.add_on_message_listener		= chrome_add_on_message_listener;
	funcs.get_app_version				= chrome_get_app_version;
	funcs.get_build_number				= chrome_get_build_number;
    funcs.get_distribution_id			= chrome_get_distribution_id;
	funcs.notifications_create 			= chrome_notifications_create;
	funcs.notifications_clear 			= chrome_notifications_clear;
	funcs.load_history 					= chrome_load_history;
	funcs.history_deleteUrl				= chrome_history_deleteUrl;
	funcs.history_onVisited_addListener = chrome_history_onVisited_addListener;
	funcs.get_resource_url 				= chrome_get_resource_url;
	funcs.storage_remove_key 			= chrome_storage_remove_key;
	funcs.storage_store 				= chrome_storage_store;
	funcs.storage_store_all				= chrome_storage_store_all;
	funcs.storage_managed_load			= chrome_storage_managed_load;
	funcs.storage_load					= chrome_storage_load;
	funcs.set_badge_icon 				= chrome_set_badge_icon;
	funcs.cancelDownload 				= chrome_cancelDownload;
	funcs.capture_screen 				= chrome_capture_screen;
	funcs.send_message					= chrome_send_message;
	funcs.usercheck_popup				= chrome_usercheck_popup;
	funcs.usercheck_password_reuse_popup= chrome_usercheck_password_reuse_popup;
	funcs.register_error_events 		= chrome_register_error_events;
	funcs.register_events 				= chrome_register_events;
	funcs.get_installation_url			= chrome_get_installation_url;
	funcs.is_tab_open					= chrome_is_tab_open;
	funcs.get_current_url 				= chrome_get_current_url;
	funcs.download_file 				= chrome_download_file;
	funcs.suggestFileName 				= chrome_suggestFileName;
	funcs.handle_open_file				= chrome_handle_open_file; 
	funcs.handle_show_folder			= chrome_handle_show_folder;
	funcs.handle_open_downloads			= chrome_handle_open_downloads;
	funcs.handle_open_options			= chrome_handle_open_options;
	funcs.get_favicon					= chrome_get_favicon;
	funcs.get_extension_name			= chrome_get_extension_name;
	funcs.create_tab					= chrome_create_tab;
	funcs.update_tab					= chrome_update_tab;
	funcs.reload_tab					= chrome_reload_tab;
	funcs.update_iframe					= chrome_update_iframe;
	funcs.close_tab						= chrome_close_tab;
	funcs.tab_send_message 				= chrome_tab_send_message;
	funcs.handle_get_orig				= chrome_handle_get_orig;
	funcs.create_context_menu			= chrome_create_context_menu;
	funcs.set_log_level					= chrome_set_log_level;
	funcs.get_locale_message			= chrome_get_locale_message;
	funcs.detect_language				= chrome_detect_language;
	funcs.get_collected_log				= chrome_get_collected_log;
	funcs.get_cookie					= chrome_get_cookie;
	funcs.browser_name					= chrome_browser_name;
	funcs.try_get_user_id				= chrome_try_get_user_id;
	funcs.get_manifest					= chrome_get_manifest;
}

//if (is_chrome_extension()) 
	load_hooks_impl = load_chrome_hooks;

var unified_URL = URL;	// a built-in object

function chrome_set_log_level(level) {
	debug = collect_log_func((level >= LOG_LVL_DEBUG) ? console.debug.bind(console) : undefined); 
	info = collect_log_func((level >= LOG_LVL_INFO) ? console.info.bind(console): undefined); 
	warn = collect_log_func((level >= LOG_LVL_WARN) ? console.warn.bind(console): undefined); 
	error = collect_log_func((level >= LOG_LVL_ERROR) ? console.error.bind(console): undefined);
}

function chrome_get_locale_message(message_key,placeholders){
	var ret = browser.i18n.getMessage(message_key, placeholders);
	if (!ret || (ret == ""))
		return message_key;
	return ret;
}

function chrome_get_distribution_id() {
   return browser.runtime.id;
}

function chrome_tab_send_message(id, message, options, func) {
	if (typeof id === "string")
		id = parseInt(id);
	try {
		browser.tabs.sendMessage(id, message, options, func);
	} catch (e) {
		browser.tabs.sendMessage(id, message, func);
	}
}

function chrome_get_extension_name() {
	return "Chrome SandBlast extension";
}

function chrome_get_favicon(url, callback) {
	getFavIcon("chrome://favicon/" + url, callback);
}

function chrome_storage_remove_key(key){
	browser.storage.local.remove(key); 
}

function chrome_storage_store(key, value, func){
	var elem = {};
	elem[key] = value;
	chrome_storage_store_all(elem, func); 
}

function chrome_storage_store_all(elem, func){
	browser.storage.local.set(elem, func); 
}

function chrome_storage_managed_load(func) {
	browser.storage.managed.get(function(policy) {
		if (browser.runtime.lastError && (browser.runtime.lastError.message.indexOf("managed") >= 0))
			func({});
		else {
			func(policy);
		}
	});
}

function chrome_storage_load(key,func) {
	browser.storage.local.get(key,func);
}

function chrome_notifications_create(id,type,progress,icon,title,message,buttons,clearBefore,contextMessage,durationSeconds) {
	var options = {
		'type': type,
		'progress': progress,
		'iconUrl': icon,
		'title': title,
		'buttons': buttons,
		'message': message // + "\n"  might need to add,
	};

	if (show_friendly_page)
		options['contextMessage'] = "Click here for more information";
	else if (contextMessage)
		options['contextMessage'] = contextMessage;

	if (durationSeconds && (durationSeconds >= 25))
		options['priority'] = 2;
	else
		options['priority'] = 0;

	if (clearBefore) {
		browser.notifications.clear(id, function () {
			browser.notifications.create(id, options, function onCreatedCallback() {
				// opera workaround. it has no buttons support so try to reload it.
				if (browser.runtime.lastError && (browser.runtime.lastError.message.indexOf("buttons") >= 0)) {
					delete options.buttons;
					browser.notifications.create(id ? id.toString() : null, options, onCreatedCallback);
				}
			});
		});
	} else {
		browser.notifications.create(id, options, function onCreatedCallback() {
			if (browser.runtime.lastError && (browser.runtime.lastError.message.indexOf("buttons") >= 0)) {
				delete options.buttons;
				browser.notifications.create(id ? id.toString() : null, options, onCreatedCallback);
			}
		});
	}
}

function chrome_notifications_clear (id) {
	browser.notifications.clear(id, function() {});
}

function chrome_get_resource_url(resource_name){
	return browser.extension.getURL(resource_name);
}

function chrome_history_deleteUrl(url) {
	browser.history.deleteUrl({"url": url});
}

function chrome_history_onVisited_addListener(onVisit_callback){
	browser.history.onVisited.addListener(function(result) {
		if (result["visitCount"] && (result["visitCount"] > 3)) 
			onVisit_callback(result);
	});
}

function chrome_set_badge_text(badge_text){
	browser.browserAction.setBadgeText({'text': badge_text});
}

function chrome_set_badge_icon(icon) {
	if (browser.browserAction)
		browser.browserAction.setIcon({'path': icon});
}

function chrome_add_on_message_listener( func ) {
	browser.extension.onMessage.addListener(func); 	
}

function chrome_get_app_version(full) {
	var match = window.navigator.userAgent.match(/Chrom(?:e|ium)\/([0-9\.]+)/);
	var version = (match && match.length > 1) ? ("(" + match[1] + ") ") : "";
	if (full === false)
		return "Chrome " + version;
	return "Chrome " + version + "SandBlast Extension " + browser.runtime.getManifest()["version"] + " (" + chrome_get_distribution_id() + ")";
}

function chrome_get_build_number(){
	return browser.runtime.getManifest()["version"];
}

function chrome_send_message(message, func){
	browser.extension.sendMessage(message, func);
}

function chrome_download_file(downloadDone_cb, params) {
	const maxUrlLenForlog = 200;
	
	if (!params || !params["url"]) {
		return false;
	}
		
	Logger.debug(Logger.modules.MAIN, mainLogSessionId, "chrome_download_file()", { "file": params["url"].substr(0,maxUrlLenForlog) });	// should not write arbitrary large data url to the log
	if (IsDataUrl(params["url"])) {
		Logger.info(Logger.modules.MAIN, mainLogSessionId, "chrome_download_file(): data-url converted to blob");
		params["url"] = unifiedCreateObjectURL(dataURItoBlob(params["url"]));
	}

	let browserDownloadArgs = {
		'url': params["url"], 
		'filename': params["filename"]
	};

	if (!IsBlobUrl(params["url"]) && params["post_data"]) {
		Logger.debug(Logger.modules.MAIN, mainLogSessionId, "chrome_download_file(): non-blob post");
		browserDownloadArgs["method"] = 'POST';
		browserDownloadArgs["body"] = params["post_data"];
		if (mapUrlToReqHeaders[params["url"]]) {											// if this is a replay of a user-initiated POST
			Logger.debug(Logger.modules.MAIN, mainLogSessionId, "chrome_download_file(): adding X-CP-TEX-Download");
			browserDownloadArgs["headers"] = [{ name: 'X-CP-TEX-Download', value: 'true'}];	// to allow original request header injection by append_headers()
		}
	}
	else {
		Logger.debug(Logger.modules.MAIN, mainLogSessionId, "chrome_download_file(): get");
		browserDownloadArgs["method"] = 'GET';
	}

	browser.downloads.download(
		browserDownloadArgs,
		function(downloadId) {
			if(browser.runtime.lastError) {
				params["error"] = browser.extension.lastError.message;
			}
			params["id"] = downloadId;
			params["download_id"] = downloadId;
			if (downloadDone_cb)
				downloadDone_cb(params);
		}
	);
	
	return true;
}

/* 
 Files downloaded by the extension (chrome.downloads.download) do not have a file name 
 so we take it from the suggestedFileNames map
 */
function chrome_suggestFileName(/*int*/ id, /*object*/ params, fileInfo) {
	var suggested = suggestedFileNames[id];
	if (!suggested) {
		suggested = {};
		suggestedFileNames[id] = suggested;
	}
	for (var param in params)
		suggested[param] = params[param];
	if (suggested["suggestCallback"] && suggested["filename"]) {
		suggested["suggestCallback"]({'filename': suggested["filename"]});
		delete suggestedFileNames[id];
	}
}
var suggestedFileNames = {};

function chrome_handle_open_file(downloadId){
	browser.downloads.open(parseInt(downloadId));
}

function chrome_handle_show_folder(downloadId) {
	browser.downloads.show(parseInt(downloadId));
}

function chrome_handle_open_downloads() {
	chrome_create_tab({'url': "chrome://downloads/"});
}

function chrome_close_tab(tab) {
	browser.tabs.remove(tab["id"]);
}

function chrome_create_tab(tab, func) {
	browser.tabs.create(tab, func);
}

function chrome_update_tab(tab_id, url) {
	browser.tabs.update(tab_id, {"url": url}, function(tab) {
		if(browser.runtime.lastError) 
			console.log("Failed to update tab " + tab_id);
	});
}

function chrome_reload_tab(tab_id) {
	browser.tabs.reload(tab_id, function(tab) {
		if(browser.runtime.lastError) 
			console.log("Failed to reload tab " + tab_id);
	});
}

/**
 * replace an iframe with URLF block page
 * @param {*} tab_id 
 * @param {*} url url of the iframe, used to locate the iframe in the page and the 'continue anyway' link
 * @param {*} scanned_url url scanned by urlf (may differ from "url" if inner url from translation service was found)
 * @param {*} block_page html of block page
 * @param {*} urlf_permit_continue_anyway
 * @param {*} incident_id 
 */
function chrome_update_iframe(tab_id, url, scanned_url, block_page, urlf_permit_continue_anyway, incident_id) {	
	var code = '(function(){ \
		var iframes=document.getElementsByTagName("iframe"); \
		for (var i = 0; i < iframes.length; i++) {  \
			var f= iframes[i]; \
			if (f.src === "'+ url + '"){ \
				f.outerHTML=\'' + block_page + '\'; \
			} \
		} \
	})()';
	
	chrome.tabs.executeScript(tab_id,{
		"allFrames": false,
		"code": code
		}, function(tab) {
		if(browser.runtime.lastError) 
			console.log("Failed to update tab " + tab_id + " iframes ");
		
		if (urlf_permit_continue_anyway) // Notify content script about created iframe usercheck
			funcs.tab_send_message(tab_id, {"command": "iframe_urlf_usercheck_created", 'incidentid': incident_id, 'url': url, 'scanned_url': scanned_url});			
	});
}

function chrome_cancelDownload(download_id) {
	browser.downloads.cancel(download_id, function() {
		browser.downloads.erase({'id': download_id});
	});
}

function chrome_get_current_url(cb) {
	browser.tabs.query({"currentWindow": true, "active": true}, function(tabs) {
		cb((tabs && tabs[0]) ? tabs[0]["url"] : undefined);
	});
}

function chrome_usercheck_password_reuse_popup(url, tab_id, index){
	chrome_create_tab({"url": url, "openerTabId": tab_id, "index": index}, function(tab) {});
}
		
function chrome_usercheck_popup(page, entry){
	var logo_64 = (items["show_urlf"] && items["user_check_logo"] && items["user_check_logo"] != "") ? ("&logo=" + b64_encode(items["user_check_logo"])) : "";
	var viewTabUrl = funcs.get_resource_url(page + "?tabID=" + entry["tabID"] + "&continue=" + (items["permit_continue_anyway"] ? "1" : "0") + logo_64);
	chrome_create_tab({"url": viewTabUrl, "openerTabId": entry["tabID"], "index": entry["tabIndex"] + 1}, function(tab) {});
}

function chrome_load_history(){
	browser.history.search({"text": "", "maxResults":10000}, function(results) {
		for (var i in results) 
			if (results[i]["visitCount"] && (results[i]["visitCount"] > 3)) 
				add_browser_history_result(results[i]);
	});
}

function chrome_register_error_events() {
	browser.webRequest.onErrorOccurred.addListener(function(info) {
		if ((info["error"] != "net::ERR_BLOCKED_BY_CLIENT") && (info["error"] != "net::ERR_ABORTED") && (info["tabId"] > 0)) 
			notify_error(info["tabId"]);
		
		if (is_service_url(info["url"])) {
			lastError = info["error"].replace(/net::/g, "").replace(/ERR_/g, "").replace(/_/g, " ").toLowerCase();
			if (lastError == "name not resolved")
				lastError = "SandBlast server is unreachable, make sure you are connected to LAN or VPN";
		}
	}, {"urls": []});

	browser.webRequest.onCompleted.addListener(function(info) {
		if ((info["statusCode"] >= 400) && (info["tabId"] > 0) )
			notify_error(info["tabId"]);
	}, {"urls": []}, []);

	browser.webNavigation.onBeforeNavigate.addListener(function(info) {
		if (info["frameId"] == 0)
			clear_tab_info(info["tabId"]);	
	});
	browser.webRequest.onBeforeRedirect.addListener(function(info) {
		var domain = getDomain(info["url"]);
		if ((info["frameId"] == 0) && (domain != getDomain(info["redirectUrl"]))) {
			if (!tabRedirects[info["tabId"]])
				tabRedirects[info["tabId"]] = [];
			tabRedirects[info["tabId"]].push(get_domain_suffix(domain));
		}
	}, {"urls": [], "types": ['main_frame']});
}

function reportIncorrectHttpClassification(tabId) {
	browser.tabs.get(parseInt(tabId), function(tab) {
		var body = encodeURIComponent("Version: " + version + "\nMisclassified URL: " + tab["url"]);
		var url = "mailto:sandblast-feedback@checkpoint.com?subject=Incorrect Zero Phishing HTTP classification&body=" + body;
		browser.tabs.update(parseInt(tabId), {"url": url});
		trackAction(undefined, "Phishing scan", "User action", "Incorrect HTTP classification");
	});	
}

function gotoSecureSite(tabId){
	browser.tabs.get(parseInt(tabId), function(tab) {
		var secured_url = tab["url"].replace("http://", "https://");
		browser.tabs.update(parseInt(tabId), {"url": secured_url});
		trackAction(undefined, "Phishing scan", "User action", "Switch to HTTPS");
	});
}

function chrome_install_callback(details) {
	if (details["reason"] == "update") {
		switch (funcs.get_distribution_id()) {
			case "hiehjkfgphmocgnpjaedeibckhndkhma":
			case "nfhcomhdpkeflibojogjhgmhdgnoghca":
				funcs.create_tab({"url": "data/feedback/deprecated.html"});
				try {
					chrome.runtime.setUninstallURL("https://chrome.google.com/webstore/detail/check-point-sandblast-zer/bnbpncoilnpdbcbfcegbjocobjppndlh");
				} catch (e) {
					// swallow exception
				}
				break;
		}
	}
	installSettings(details["reason"], details["previousVersion"]);
}

function chrome_get_installation_url(callback) {
	browser.tabs.query({}, function(tabs) {
		for (var i = 0; i < tabs.length; i++) 
			if ((tabs[i].url.indexOf('?') > 0) && (tabs[i].url.indexOf(chrome_get_distribution_id()) > 0)) 
				return callback(tabs[i].url);
		return callback(undefined);
	});
}

function chrome_is_tab_open(url, activate, callback) {
	browser.tabs.query({}, function(tabs){
		for (var i = 0; i < tabs.length; i++) 
			if (tabs[i].url.indexOf(url) >= 0)  {
				if (activate)
					browser.tabs.update(tabs[i]["id"], {"active": true, "highlighted": true}, function(tab) {});
				return callback(true);
			}
		return callback(false);
	});
}

function chrome_register_events() {
	browser.runtime.onInstalled.addListener(chrome_install_callback);
	
	browser.notifications.onClosed.addListener(function(notificationId, byUser) {
		if (byUser)
			event_notification_by_user_closed(notificationId);
		else
			event_notification_automatically(notificationId);
	});
	
	browser.webRequest.onBeforeSendHeaders.addListener(function(details) {
		var appendedRequestHeaders = append_headers(details.requestHeaders,details.url);
		return {'requestHeaders': appendedRequestHeaders};
	}, {'urls': []}, ["requestHeaders", "blocking"]);
 
	browser.webRequest.onHeadersReceived.addListener(function(details) { /* Disable internal PDF viewer */
		var res = modify_responseHeaders(details.responseHeaders, details.url, details.statusCode);
		if (res && res["modified"])
			return {'responseHeaders':res["responseHeaders"]};
	}, {'urls': []}, ['blocking', 'responseHeaders']);

	browser.webRequest.onBeforeRequest.addListener(function(details) {
		const postDataSizeLimit = 500000;
		const logMsg_prefix = "browser.webRequest.onBeforeRequest handler [" + details["url"] + "]: ";
		const logMsg_postDataTooLarge = logMsg_prefix + "post data too large";

		if ((details["method"] === "POST") && details["requestBody"] && (details["tabId"] >= 0)) {
			// no need to save post data for posts to our services
			if (is_service_url(details["url"])) {
				return;
			}
			if (details["requestBody"]["formData"]) {	// if request body was deserialized by the browser
				Logger.debug(Logger.modules.MAIN, mainLogSessionId, "post data found in requestBody.formData");

				// we assume that no one posts large data in order to download a file
				if (details["requestBody"]["formData"].length > postDataSizeLimit) { 
					Logger.debug(Logger.modules.MAIN, mainLogSessionId, logMsg_postDataTooLarge);
					return;
				}
				
				var formData = details["requestBody"]["formData"];
				if (formData["disposition"] && (formData["disposition"].length > 1))  // workaround for multiple disposition chrome bug
					formData["disposition"] = formData["disposition"].filter(function(elem, index, self) { return index == self.indexOf(elem); });
				savePostData(details["url"], serialize(formData));
			}
			else {
				if (details["requestBody"]["raw"]) {	// if request body was not deserialized by the browser
					Logger.debug(Logger.modules.MAIN, mainLogSessionId, "post data found in requestBody.raw");
					
					// check post data size limit
					let totalByteLength = details["requestBody"]["raw"].reduce((accumulator, currentValue) => accumulator += currentValue["bytes"]["byteLength"], 0);
					if (totalByteLength > postDataSizeLimit) {
						Logger.debug(Logger.modules.MAIN, mainLogSessionId, logMsg_postDataTooLarge);
						return;
					}
					
					// concat raw buffer parts into a single buffer
					let buffer = new Uint8Array(totalByteLength);
					let offset = 0;
					details["requestBody"]["raw"].forEach((bufferPart) => {
						buffer.set(new Uint8Array(bufferPart["bytes"]), offset);
						offset += bufferPart["bytes"]["byteLength"];
					});
					savePostData(details["url"], buffer);
				}
			}
		}

		if (items["urlf_enabled"] && items["urlf_force_safe_search"]) {
			var redirect_url = force_safe_search(details["url"]);
			if (redirect_url)
				return {"redirectUrl": redirect_url};
		}
	}, {'urls': []}, ['blocking', 'requestBody']);
	
	browser.storage.onChanged.addListener(function(changes, namespace) {
		if (namespace == "managed") 
			check_managed_changes();
	});
	
	browser.notifications.onButtonClicked.addListener(function(notificationId, buttonIndex) {
		funcs.notifications_clear(notificationId);
		var in_progress = false;
		if (notificationId.indexOf("progress_") == 0) {
			notificationId = notificationId.substr("progress_".length);
			in_progress = true;
		}

		if (notificationId.indexOf("theft_") == 0) { // Zero Phishing action buttons
			if (buttonIndex == 0) {
				if (in_progress) 
					cancel_scan(notificationId);
				else
					reportIncorrectHttpClassification(notificationId.substr("theft_".length));
			}
			else if (buttonIndex == 1) 
				gotoSecureSite(notificationId.substr("theft_".length));					
		}
		else { // TEX action buttons
			if (buttonIndex == 0) {
				if (in_progress) 
					cancelDownloadInProgress(parseInt(notificationId));
				else
					chrome_handle_open_file(notificationId);
			}
			else if (buttonIndex == 1)
				chrome_handle_show_folder(notificationId);
		}
	});
	
	/* Respond to the user's clicking on the notification message-body */
	browser.notifications.onClicked.addListener(function(notificationId) {
		notification_clicked(notificationId);
	});
	
	if (getAccountId() != "zone_alarm_account" && getAccountId() != "zone_alarm_internal_account") {

		var unhandledDownloads = {}; //downloads for which onDeterminingFilename was not called

		browser.downloads.onCreated.addListener(function(download) {
			if (download.byExtensionId != browser.runtime.id)
				unhandledDownloads[download.id] = download;
		});

		browser.downloads.onChanged.addListener(function(downloadItem) {
			if (downloadItem["state"] && (downloadItem["state"]["current"] != "in_progress")) {
				let download = unhandledDownloads[downloadItem.id];
				delete unhandledDownloads[downloadItem.id];
				if (download && (downloadItem["state"]["current"] == "complete")) {
					let fixed_download = fix_download_for_redirect(download);
					if (handle_file_download(fixed_download)) {
						browser.downloads.removeFile(downloadItem.id);
					}
				}
			}
		});

		browser.downloads.onDeterminingFilename.addListener(function(download, suggest) {
			let logPrefix = "onDeterminingFilename(): ";
			delete unhandledDownloads[download.id];
			// files downloaded by the extension (chrome.downloads.download) do not have a file name so we take it from the suggestedFileNames map
			if (download.byExtensionId === browser.runtime.id) {
				chrome_suggestFileName(download.id, {"suggestCallback" : suggest});
			}
			else if (items["show_urlf"] && officeEditingDistributionIds[download.byExtensionId]) {
				Logger.info(Logger.modules.MAIN, mainLogSessionId, "download was invoked from 'Office Editing for Docs, Sheets & Slides' extension");
				handleOfficeEditingExtDownload(download, suggest);
				return true;	// suggest will be called asyncly, so must return true
			}
			else {
				let fixed_download = fix_download_for_redirect(download);
				return handle_file_download(fixed_download, suggest);	// if false, chrome will call suggest automatically
			}
		});
	}
	
	/**
	 * Helper function to prepare params for URLF check and call it
	 * @param {Object} details navigation details received from a chrome.webNavigation event callback
	 * @param {Object} tab tab details received from chrome.tabs.get callback
	 */
	let invokeUrlfCheck = function(details, tab) {
		const isTopFrame = (details["frameId"] == 0);
		let urlfParams;

		if (isTopFrame) 	// if navigation occurs on the main frame, set the top url to the navigation destination url
			urlfParams = Object.assign({ "top_url": details["url"] }, details);
		else 				// if navigation occurs in a subframe, set the top url to be that of the parent tab
			urlfParams = Object.assign({ "top_url": tab["url"] }, details);
		
		urlf_check(urlfParams);
	};

	/**
	 * Log the lastError of a chrome.tabs.get, but ignore not relevant errors
	 * @param {string} logPrefix prefix for output log line, should be the name of the caller function
	 */
	let chromeTabLogLastError = function(logPrefix) {
		const errNoTabMsg = "No tab with id";
		if (browser.runtime.lastError.message) {
			if (browser.runtime.lastError.message.indexOf(errNoTabMsg) < 0) {
				Logger.error(Logger.modules.MAIN, mainLogSessionId, "webNavigation.onBeforeNavigate callback", "message:" + browser.runtime.lastError.message);
			}
		}
	};

	browser.webNavigation.onCompleted.addListener(function(details) {
		const logPrefix = "webNavigation.onCompleted callback: ";
		const isTextDataUrl = (details["url"].indexOf("data:text") == 0);
		const isTopFrame = (details["frameId"] == 0);
		const isZeroPhishEnabled = (items["identity_protection_enabled"] && (items["phishing_detection_mode"] != 0));

		// identify top frame navigation to data url, and invoke ZF scan on it
		if (isTextDataUrl) {
			if (isTopFrame && isZeroPhishEnabled) {
				browser.tabs.get(details["tabId"], function(tab) {
					if (browser.runtime.lastError)
						chromeTabLogLastError(logPrefix);
					else 
						scan_data_url(tab);
				});
			}
		}
	});
	
	browser.webNavigation.onBeforeNavigate.addListener(function(details) {
		const logPrefix = "webNavigation.onBeforeNavigate callback: ";
		
		browser.tabs.get(details["tabId"], function(tab) {
			if (browser.runtime.lastError)
				chromeTabLogLastError(logPrefix);
			else
				invokeUrlfCheck(details, tab);
		});
	});
}

function chrome_capture_screen(entry, func) {
	try {
		browser.windows.update(entry["windowID"], {"focused": true}, function(win) {
			try {
				browser.tabs.update(entry["tabID"], {"active": true, "highlighted": true}, function(tab) {
					try {
						browser.tabs.captureVisibleTab(function(screenshotUrl) {		
							func(screenshotUrl);	
						});
					} catch (e1) {
						Logger.error(Logger.modules.MAIN, mainLogSessionId, "failed to capture screen");
						func(undefined);
					}
				});
			} catch (e2) {
				Logger.error(Logger.modules.MAIN, mainLogSessionId, "failed to update tab");
				func(undefined);
			}
		});
	} catch (e3) {
		Logger.error(Logger.modules.MAIN, mainLogSessionId, "failed to update window");
		func(undefined);
	}
}

function chrome_handle_open_options () {
	//browser.runtime.openOptionsPage();
	funcs.is_tab_open(funcs.get_resource_url("data/options.html"), true, function(is_open) {
		if (!is_open)
			funcs.create_tab({"url": funcs.get_resource_url("data/options.html")});	
	});
}

function chrome_handle_get_orig(orig_file_url, orig_file_name, quarantine){
	handle_get_orig(orig_file_url,orig_file_name,quarantine);
}

function chrome_create_context_menu() {
	if (contextMenuIDs.indexOf("clearSite") < 0) {
		contextMenuIDs.push("clearSite");
		browser.contextMenus.create({
			"title": funcs.get_locale_message("LOCALE_REMOVE_SITE_FROM_TRUSTED_SITES"),
			"id": "clearSite",
			"contexts": ["browser_action"],
			"onclick": clearSite
		});
	}
	
	if (contextMenuIDs.indexOf("scanSite") < 0) {
		contextMenuIDs.push("scanSite");
		browser.contextMenus.create({
			"title": funcs.get_locale_message("LOCALE_SCAN_SITE"),
			"id": "scanSite",
			"contexts": ["browser_action"],
			"onclick": function() {
				browser.tabs.query({"currentWindow": true, "active": true}, function(tabs) {
					if (tabs && tabs[0]) {
						var msg = {command: "manual_scan"};
						Logger.debug(Logger.modules.MAIN, mainLogSessionId, "zero-phishing manual scan requested");
						funcs.tab_send_message(tabs[0]["id"], msg);
					} 
				});
			}
		});
	}
	if (getAccountId() == "zone_alarm_account" || getAccountId() == "zone_alarm_internal_account") {
		if (contextMenuIDs.indexOf("collectLogs") < 0  )  {
				contextMenuIDs.push("collectLogs");
				chrome.contextMenus.create(
					{"title": "Collect Logs",
					"id": "collectLogs",
					"contexts": ["browser_action"],
					"onclick": saveCollectedLogs
				});
			}
		}
}

function chrome_detect_language(tabId, cb) {
	try {
		if (browser.tabs.detectLanguage)
			browser.tabs.detectLanguage(tabId, cb);
		else
			cb("en");
	} catch (e) {
		cb("en");
	}
}

function chrome_get_collected_log() {
	return encrypt_text(JSON.stringify(items, undefined, "\t") + "\n" + get_collected_log(), log_collect_key);
}

function chrome_get_cookie(url, xhr) {
	return xhr ? xhr.getResponseHeader("My-Set-Cookie") : undefined;
}

function chrome_browser_name(){
	return browser_name["chrome"];	
}

function chrome_try_get_user_id(callback) {
	let userid = undefined;

	if (browser && browser["identity"] && browser["identity"]["getProfileUserInfo"]) {
		browser["identity"]["getProfileUserInfo"](function(userInfo) { 
			if (userInfo && userInfo["email"])
				userid = userInfo["email"];
            callback(userid);
		});
	}
}

function chrome_get_manifest() {
	return browser.runtime.getManifest();
}


// correctly handle redirected download requests
// to be used with all browsers implementing Chromium extensions API
function fix_download_for_redirect(download) {
	var fixed_download = Object.assign({}, download);											// make shallow copy, no nested objects assumed
	if (fixed_download["finalUrl"] && (fixed_download["finalUrl"] != fixed_download["url"])) {	// url property may now exist if download obj is received from 'downloads.onChanged' callback
		fixed_download["url"] = fixed_download["finalUrl"];
	}
	return fixed_download;
}


/*
	Properly suggest filename for office document downloads initiated from "Office Editing for Docs, Sheets & Slides" extension.
	In Chrome OS, this extension is the defualt viewer for offline office documents.
	This is a K12 specific fix.
*/
function handleOfficeEditingExtDownload(download, suggest) {
	const logPrefix = "handleOfficeEditingExtDownload(): ";
	const searchUrl = 'chrome-extension://' + download.byExtensionId + '/views/app.html';
	const checkFileExtension = false;	// true if should check that tab title looks like an office file name

	// call this to perform file name suggestion based on tab title
	const fnAttemptSuggestFilename = (tab) => {
		let suggestedFileName = tab["title"];
		if (checkFileExtension) {
			let suggestedFileExtension = suggestedFileName ? getFileExtension(suggestedFileName) : "";
			if (suggestedFileExtension && suggestedFileExtension !== "" && officeFileExtension2Mime[suggestedFileExtension]) {
				suggest({ "filename": suggestedFileName });
				Logger.info(Logger.modules.MAIN, mainLogSessionId, "suggested filename", { "name": suggestedFileName });
			}
			else {
				suggest();
				Logger.warn(Logger.modules.MAIN, mainLogSessionId, "tab title does not seem to contain a valid file name", { "suggested_name": suggestedFileName });
			}
		}
		else {
			if (suggestedFileName) {
				suggest({ "filename": suggestedFileName });
				Logger.info(Logger.modules.MAIN, mainLogSessionId, "suggested filename", { "name": suggestedFileName });
			}
			else {
				suggest();
				Logger.warn(Logger.modules.MAIN, mainLogSessionId, "tab title does not seem to contain a valid file name");
			}
		}
	};

	// get active tab of "Office Editing for Docs, Sheets & Slides" extension
	browser.windows.getLastFocused({
		"populate": false, 
		"windowTypes": ["normal"] 
	}, (focusedWnd) => {
		if (focusedWnd && focusedWnd.id !== null && focusedWnd.id !== undefined) {
			browser.tabs.query({
				"url": searchUrl,
				"windowId": focusedWnd.id,
				"active": true
			}, (tabArray) => {
				if (tabArray.length == 1) {
					fnAttemptSuggestFilename(tabArray[0]);
				}
				else {
					suggest();
					Logger.info(Logger.modules.MAIN, mainLogSessionId, "got invalid number of tabs", { "tabs": tabArray.length });
				}
			});
		}
		else {
			suggest();
			Logger.warn(Logger.modules.MAIN, mainLogSessionId, "cannot get active window");
		}
	});
}