load_hooks();

var url = "";
var title = "";
var urlVars = getUrlVars();

function closeWindow() {
    if (is_ie_extension())
        window.open('', '_self').close();
    else if (is_firefox_quantum_extension())
        funcs.close_current_tab();
    else
        window.close();
}

function continueAnywayReuse() {
    funcs.send_message({
        "command": "continue_anyway_password_reuse",
        "link": this["href"],
        "url": url,
        "tabID": Number(urlVars["tabID"])
    });
    closeWindow();
    return false;
}

function getUrlVars() {
    var vars = {};
    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).replace("#", '').split('&');
    for (var i = 0; i < hashes.length; i++) {
        var hash = hashes[i].split('=');
        vars[hash[0]] = hash[1];
    }
    return vars;
}

function sendReport() {
    funcs.send_message({
        "command": "continue_anyway",
        "link": this["href"],
        "url": url,
        "title": title,
        "tabID": urlVars["tabID"]
    });
    closeWindow();
    return false;
}

function continueAnyway() {
    funcs.send_message({"command": "continue_anyway", "url": url, "title": title, "tabID": urlVars["tabID"]});
    closeWindow();
    return false;
}

function toggle() {
    var ele = document.getElementById("target3");
    var text = document.getElementById("displayText");
    var cont = document.getElementById("continueAnyway");
    var images = document.getElementById("imageSimilarity");

    if (ele.style.display == "block") {
        ele.style.display = "none";
        cont.style.display = "none";
        images.style.display = "none";
        text.textContent = funcs.get_locale_message("LOCALE_PHISHING_DETAILS");
    }
    else {
        ele.style.display = "block";
        if (urlVars["continue"] == "1")
            cont.style.display = "block";
        images.style.display = "block";
        text.textContent = funcs.get_locale_message("LOCALE_HIDE_DETAILS");
    }
}

function set_usercheck_content(content) {
	if (content["image"] && content["match_image"]) {
		document.getElementById("target1").style.backgroundImage = "url('"+content["match_image"] + "')";
		document.getElementById("target2").style.backgroundImage = "url('"+content["image"] + "')";
	}
	document.getElementById("target3")["innerHTML"] = content["findings_text_html"];
	document.getElementById("siteDomain")["textContent"] = content["match_domain"] ? content["match_domain"] : "another site";
	url = content["url"];
	document.getElementById("url")["innerHTML"] = url;
	title = (content["title"] ? content["title"] : "");
	document.getElementById("title")["innerHTML"] = title;
	if (document.getElementById("send_report")) {
		var body = "*******************************************************\n";
		body += "Please attach/drag the downloaded log file to this mail\n";
		body += "*******************************************************\n\n";
		body += "Version: " + content["version"] + "\nMisclassified URL: " + content["top_url"] + "\nIndicators:\n" + content["findings_text"] +"\n" + content["findings"];
		document.getElementById("send_report").href = "mailto:sandblast-feedback@checkpoint.com?subject=Incorrect Zero Phishing classification&body=" + encodeURIComponent(body);
		document.getElementById("send_report").textContent = funcs.get_locale_message(((urlVars["continue"] == "1") ? "LOCALE_PHISHING_SEND_REPORT_AND_CONTINUE" : "LOCALE_PHISHING_SEND_REPORT"));
	}

    if (content.url != null && content.url != "" && content.match_domain != null && content.match_domain != "") {
        var xhr = new XMLHttpRequest();
        xhr.open("POST", "http://www.checkpoint.com/onp/zero_phishing", true);
        var postData = {
            "malicious-url": content.url,
            "original-url": content.match_domain,
            // "incident-id": content.incident_id,
        };
        xhr.send(JSON.stringify(postData));
    }
}


funcs.add_on_message_listener(function handleMessage(msg, sender, sendResponse) {
    if ("locales" in msg)
        locales = msg["locales"];
    if ("en_locales" in msg)
        en_locales = msg["en_locales"];
    localizeHTML();

    if (document.getElementById("displayText"))
        document.getElementById("displayText").addEventListener("click", toggle);
    if (document.getElementById("exit_button"))
        document.getElementById("exit_button").addEventListener("click", closeWindow);
    if (document.getElementById("send_report_reuse"))
        document.getElementById("send_report_reuse").addEventListener("click", continueAnywayReuse);
    if (document.getElementById("continueLink") && (urlVars["continue"] == "1"))
        document.getElementById("continueLink").addEventListener("click", continueAnyway);
    if (document.getElementById("send_report"))
        document.getElementById("send_report").addEventListener("click", sendReport);
    if (document.getElementById("non") && urlVars["non"])
        document.getElementById("non").textContent = atob(urlVars["non"]);
    if (document.getElementById("cor") && urlVars["cor"])
        document.getElementById("cor").textContent = atob(urlVars["cor"]);
    if (document.getElementById("usercheck_company_logo"))
        document.getElementById("usercheck_company_logo").src = (urlVars["logo"] && urlVars["logo"] != "") ? atob(decodeURIComponent(urlVars["logo"])) : "./UserCheck_files/cplogo.png";

    if (document.getElementById("send_report_reuse")) {
        var body = "*******************************************************\n";
        body += "Please attach/drag the downloaded log file to this mail\n";
        body += "*******************************************************\n\n";
        body += "Corporate domain: " + atob(urlVars["cor"]) + "\nNon-corporate domain: " + atob(urlVars["non"]).replace("(", "").replace(")", "");
        document.getElementById("send_report_reuse").href = "mailto:sandblast-feedback@checkpoint.com?subject=Incorrect Zero Phishing password reuse classification&body=" + encodeURIComponent(body);
    }

	if ((msg["command"] == "usercheck_content") && document.getElementById("target3"))
		set_usercheck_content(msg);

    if(msg != null){
	    funcs.send_message({'command' : 'report_to_ios', 'url' : msg.url , 'match_domain' : msg.match_domain})
	}
});
funcs.send_message({'command': 'get_usercheck_content', 'tabID': Number(urlVars["tabID"])});
